/*
 * (C) Copyright 2007-2013
 * Allwinner Technology Co., Ltd. <www.allwinnertech.com>
 * Jerry Wang <wangflord@allwinnertech.com>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <asm/assembler.h>


/*
************************************************************************************************************
*
*                                             arm_neon_init
*
*    name          :
*
*    parmeters     :
*
*    return        :
*
*    note          :
*
*
************************************************************************************************************
*/
	.balign   4
	.global   arm_neon_init     @r0ʼַr1ֽ

arm_neon_init:

	stmfd sp!, {lr}

	ldr r0, =(0xf<<20)
	mcr p15, 0, r0, c1, c0, 2   @(enable CP10/CP11, and disable ASEDIS/D32DIS)

	mov r0, #0
	mcr p15, 0, r0, c7, c5, 4   @(CP15ISB)

	mov r0, #0x40000000
	fmxr fpexc, r0              @(enable NEON)

	isb                         @(wait all code are executed including pipeline)
	dsb                         @(wait all register access are finished)

	mov r0, #0

	ldmfd sp!, {pc}


/*
************************************************************************************************************
*
*                                             add_sum_neon
*
*    name          :
*
*    parmeters     :   r0, ʼַ   r1, ֽ
*
*    return        :
*
*    note          :
*
*
************************************************************************************************************
*/
	.balign   4
	.global   add_sum_neon     @r0ʼַr1ֽ
	.arm

add_sum_neon:
    stmfd sp!, {r2-r6, lr}

	mov r2, r0
	mov r3, r1
	mov r5, #0                          @ʼr5=0淵ֵ
	vbic.I32 q0, #0x000000ff
	vbic.I32 q0, #0x0000ff00
	vbic.I32 q0, #0x00ff0000
	vbic.I32 q0, #0xff000000

    cmp r3, #31
    bls __data_deal_32byte_unalign_0

__data_read_loop:
	vld1.I32 {d2, d3, d4, d5}, [r2]!    @r2ʼݣȡ8(64/8)*4ֽڵd0-d3УQ0Q1ɺr2Զ仯һȡַ
	vadd.I32 q3, q1, q2
	vadd.I32 q0, q0, q3                 @浽Q0
	sub r3, r3, #32                     @r3(ֽ)ȥ32ֽ
	cmp r3, #31
	bhs __data_read_loop

	vadd.I32 d0, d0, d1
	vmov r5, r6, d0
	adds r5, r5, r6                     @r5淵ֵ

__data_deal_32byte_unalign_0:
	and r4, r3, #3                      @r44ֽڶֽ
	lsr r3, r3, #2                      @r34ֽڶĸ
__data_deal_32byte_unalign_1:
	cmp r3, #0                          @鿴Ƿδ4ֽڶ
	beq __data_deal_4byte_unalign
	ldr r6, [r2], #4                    @
	adds r5, r5, r6                     @ۼ
	sub r3, r3, #1                      @ݼ1
	b __data_deal_32byte_unalign_1

__data_deal_4byte_unalign:              @δ
	cmp r4, #0
	beq __data_deal_return
	rsb r4, r4, #4
	lsl r4, r4, #3
	mvn r6, #0
	lsr r6, r6, r4
	ldr r3, [r2], #4                   @
	and r6, r3, r6
	adds r5, r5, r6

__data_deal_return:
	mov r0, r5

	ldmfd sp!, {r2-r6, pc}
/*
************************************************************************************************************
*
*                                             memcpy_neon
*
*    name          :
*
*    parmeters     :
*
*    return        :
*
*    note          :
*
*
************************************************************************************************************
*/
	.align 4
	.global memcpy_neon
	.arm

memcpy_neon:
	cmp  r2, #0
	moveq pc, lr

	cmp r0, r1
	moveq pc, lr

	stmfd sp!, {r3-r9, lr}

	mov  r3, r0         			@r3Ŀĵַ
	mov  r4, r1         			@r4Դַ
__memcpy_loop:
    cmp r2, #31 			        @жϴֽǷС32ֽ
    bls __memcpy_neon_32byte_unalign_0
	vld1.I32 {d2,d3,d4,d5}, [r4]!   @r4ʼȡ32ֽڶQ1Q2
	vst1.I32 {d2,d3,d4,d5}, [r3]!   @Q1Q2ݴŵr3ʼĵַ
	sub r2, r2, #32
	b __memcpy_loop

__memcpy_neon_32byte_unalign_0:
	PLD(pld [r3, #0])
	PLD(pld [r4, #0])
	and r5, r2, #3                  @r54ֽڶֽ
	lsr r6, r2, #2                  @r64ֽڶĸ
__memcpy_neon_32byte_unalign_1:
	cmp r6, #0
	beq __memcpy_neon_4byte_unalign
	ldr r7, [r4], #4
	str r7, [r3], #4
	sub r6,r6,#1
	b __memcpy_neon_32byte_unalign_1
__memcpy_neon_4byte_unalign:
	cmp r5, #0
	beq __memcpy_neon_exit
	ldr r7, [r4], #4          @Դַһwordr7϶ȡ
	ldr r8, [r4]              @Ŀĵַһwordr8
	mvn r9, #0
	rsb r5, r5, #4
	lsl r5, r5, #3            @r5=r5*8
	lsl r9, r9, r5
	and r8, r8, r9            @Ŀĵַr8Ҫдλ
	mvn r6, #0
	eor r9, r9, r6
	and r7, r7, r9            @Դַr7㲻дλ
	orr r7, r7, r8            @ϲr7r8õȷ
	str r7, [r3], #4

__memcpy_neon_exit:
    ldmfd sp!, {r3-r9, lr}

/*
************************************************************************************************************
*
*                                             bmpdecode_neon
*
*    name          :
*
*    parmeters     :  r0: bmpԭʼݵַ
*
*                     r1: ݴŵַ
*
*                     r2: ṹĵַ
*
*						{
*							int x;     xص
*							int y;     yص
*							int bmp_bpix;  ÿصֽ
*						}
*
*    return        :  
*
*    note          :  ȡĲǣÿζȡ32ֽ(һֽ(xص*ÿصֽ)ʱ)
*                                   16ֽڲ32ֽڣһζȡ16ֽ
*                                   8ֽҲ16ʱһζȡ8ֽ
*                                   8ֽʱҲΪ0ʱһζȡ8ֽ
*
*                                   ARGBʽÿΪص㣬һ4ֽڣȻԴַĿĵַҪ4ֽ
*                                                   ÿΪżص㣬ոպʣ
*
*                                   RGBʽÿЧֽΪ3xֽΪx&3(4ֽڶ)
*                                   ٶȡ8ֽڣҪֽ֪ڿԲ8ֽڶ룬Ȼȡ
*                                   㷨3x=Чֽ
*                                         3x&7=û8ֽڶĲ
*                                         x=8m+nnȡֵΪ173x=3(8m+n)=24m+3n,nȡֵ(0ֱֵӲ)
*                                         ֵΪ3,6,9,12,15,18,21
*										  ٺ7룬ֵΪ3,6,1,4,7,2,5
*										  Ҳû8ֽڶĲ
*                                         8ЩֵõҪֽ֤ȡܴﵽһ8ֽ
*                                         ֵ5,2,7,4,1,6,3
*                                         ǶأҪԴֵַӦ(&4)
*
*                     Ĵʹ   r0  Դַ
*
*                                  r1  Ŀĵַ
*
*                                  r2  ṹַ(ȡЧ)
*                                      汣xص
*
*                                  r3  yص
*
*                                  r4  ÿصֽ
*
*                                  r5  Ŀĵַдֽ
*
*                                  r6  Դַȡֽ
*
*                                  r7  һеЧֽ
*
*
*
************************************************************************************************************
*/
	.align 4
	.global bmpdecode_neon
	.arm

bmpdecode_neon:
	cmp r2, #0						@ṹַǷϷ
	moveq pc, lr

	cmp r0, r1                      @ԭʼַǷĿĵַ
	moveq pc, lr

	stmfd sp!, {r0-r8, lr}

	ldr r3, [r2, #4]                @r3yص
	ldr r4, [r2, #8]                @r4ÿصֽ
	ldr r2, [r2]                    @r2xص

	cmp r4, #0
	beq __bmpdecode_filling_exit

	cmp r4, #4                      @жһصֽ
	beq __bmpdecode_x_4pixles

									@һص3ֽڵ
	lsl r7, r4, #2
	sub r7, r7, r4					@r7һЧֽ  r7=3*r4
	and r5, r7, #7
	rsb r5, r5, #8					@r5û8ֽڶֽڲ, д
	and r6, r5, #4					@r6Ҫֽڲ֣ȡ

	b __bmpdecode_y_loop

__bmpdecode_x_4pixles:              @һص4ֽڵ
	and r5, r2, #1
	cmp r5, #1                      @жǷص
	lsleq r5, r5, #2                @գԴַĿĵַҪȥ4д

	mov   r6, r5
	lsl r7, r4, #2

__bmpdecode_y_loop:
	mov r8, r7
__bmpdecode_x_loop:
    cmp r8, #31                     @һδ32ֽ
	bls __bmpdecode_filling_32bytes_less

    vld1.I32 {d2,d3,d4,d5}, [r0]!    @һζȡ32ֽ
    vst1.I32 {d2,d3,d4,d5}, [r1]!    @һδ洢32ֽ
	sub r8, r8, #32

    b __bmpdecode_x_loop

__bmpdecode_filling_32bytes_less:
	cmp r8, #15
	bls __bmpdecode_filling_16bytes_less

	vld1.I32 {d2, d3}, [r0]!    			@һζȡ16ֽ
    vst1.I32 {d2, d3}, [r1]!    			@һδ洢16ֽ

	sub r8, r8, #16
__bmpdecode_filling_16bytes_less:
	cmp r8, #7
	beq __bmpdecode_filling_8bytes_less

	vld1.I32 {d2}, [r0]!    			@һζȡ8ֽ
    vst1.I32 {d2}, [r1]!    			@һδ洢8ֽ

    sub r8, r8, #8
__bmpdecode_filling_8bytes_less:
	cmp r8, #0
	beq __bmpdecode_filling_x_finish

	vld1.I32 {d2}, [r0]!    			@һζȡ8ֽ
    vst1.I32 {d2}, [r1]!    			@һδ洢8ֽ

	sub r1, r1, r5						@Ŀĵַ
	sub r0, r0, r6						@Դַ

__bmpdecode_filling_x_finish:

	sub r4, r4, #1                  @1
	cmp r4, #0

	bne __bmpdecode_y_loop

__bmpdecode_filling_exit:

	stmfd sp!, {r0-r8, pc}

